org.klomp.snark

## Class Request

- java.lang.Object
- - org.klomp.snark.Request

-     class Request
      extends Object

  Holds all information needed for a partial piece request. This class should be used only by PeerState, PeerConnectionIn, and PeerConnectionOut.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) int` | `len`
    `(package private) int` | `off`
    `(package private) long` | `sendTime`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Request(PartialPiece piece, int off)` Dummy Request for PeerState.returnPartialPieces().
    `Request(PartialPiece piece, int off, int len)` Creates a new Request.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object o)`
    `PartialPiece` | `getPartialPiece()` The PartialPiece this Request is for
    `int` | `getPiece()` The piece number this Request is for
    `int` | `hashCode()`
    `void` | `read(DataInputStream din, BandwidthListener bwl)`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### len

          final int len

    - #### off

          final int off

    - #### sendTime

          long sendTime

  - ### Constructor Detail

    - #### Request

          Request(PartialPiece piece,
                  int off)

      Dummy Request for PeerState.returnPartialPieces(). len will be zero.
      Parameters:
        `piece` - Piece number requested.
        `off` - the offset in the array.

    - #### Request

          Request(PartialPiece piece,
                  int off,
                  int len)

      Creates a new Request.
      Parameters:
        `piece` - Piece number requested.
        `off` - the offset in the array.
        `len` - the number of bytes requested.

  - ### Method Detail

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### getPartialPiece

          public PartialPiece getPartialPiece()

      The PartialPiece this Request is for

    - #### getPiece

          public int getPiece()

      The piece number this Request is for

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### read

          public void read(DataInputStream din,
                           BandwidthListener bwl)
                    throws IOException

      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`